;            ͻ
;                 HARDWARE.INC      
;                                                               
;                       Hardware functions (DMA/IRQ)            
;            ĺ
;               By Freddy Vtel (FreddyV/Useless)              
;                                                               
;               Code Starts .................. 05/09/1996       
;               Last Update .................. 12/09/1996       
;            ͼ
; Advice: It's used only in the SB driver.

INCLUDE OS.INC

; DOS32 And PMODEW uses DPMI functions.
Ifdef DOS32
DPMI_IRQ EQU 1
Endif

Ifdef PMODEW
DPMI_IRQ EQU 1
EndIf

DMAAutoinit   EQU 8+16+64
DMANoAutoinit EQU 8+64

Global ZeroOffset     :DWORD  ;Program Address 
Global PSPOffset      :DWORD

Global DMABuffer      :DWORD
Global DMARealAddress :DWORD

Global HardwareInit :NEAR
Global HardwareEnd  :NEAR

Global IRQ_Enable   :NEAR
Global IRQ_Disable  :NEAR

Global GetEnvOffset :NEAR

Global DMA_Setup    :NEAR

;******************** DPMI **********************

Ifdef DPMI_IRQ

DPMI_GetInt EQU 204h
DPMI_SetInt EQU 205h

GetInt Macro Inter,_Ptr
	mov bl,Inter
	
        mov ax,DPMI_GetInt
        int 31h	
	mov DWORD PTR _Ptr,edx	; Save Int offset
        mov WORD PTR _Ptr[4],cx	; Save Int selector	
Endm

RestInt Macro Inter,_Ptr
       	mov bl,Inter
	mov cx,WORD PTR _Ptr[4]
        mov edx,DWORD PTR _Ptr
	
	mov ax,DPMI_SetInt
        int 31h
Endm

SetInt Macro Inter,Select,Offs
        mov bl,Inter
	mov cx,Select
	mov edx,Offset Offs
	
	mov ax,DPMI_SetInt
        int 31h
Endm

GetIRQ Macro IRQ,_Ptr
Local SmallIRQ

        mov bl,IRQ
	cmp bl,7
        jbe SmallIRQ
        add bl,60h           ;Interrupt = IRQ+68h
SmallIRQ:                       
        add bl,8             ;Interrupt = IRQ+8

	mov ax,DPMI_GetInt
        int 31h
	mov DWORD PTR _Ptr,edx	; Save IRQ offset
        mov WORD PTR _Ptr[4],cx	; Save IRQ selector	
Endm

RestIRQ Macro IRQ,_Ptr
Local SmallIRQ

        mov bl,IRQ
	cmp bl,7
        jbe SmallIRQ
        add bl,60h           ;Interrupt = IRQ+68h
SmallIRQ:                       
        add bl,8             ;Interrupt = IRQ+8

	mov cx,WORD PTR _Ptr[4]
        mov edx,DWORD PTR _Ptr        

	mov ax,DPMI_SetInt
        int 31h       
Endm

SetIRQ Macro IRQ,Select,Offs 
Local SmallIRQ

        mov bl,IRQ
	cmp bl,7
        jbe SmallIRQ
        add bl,60h           ;Interrupt = IRQ+68h
SmallIRQ:                       
        add bl,8             ;Interrupt = IRQ+8
        
	mov cx,Select
	mov edx,Offset Offs
	
	mov ax,DPMI_SetInt
        int 31h
Endm

Endif

;******************* EOS *********************

Ifdef EOS

GetInt Macro Inter,_Ptr
        mov bl,Inter
        mov ah,Get_Int
        int_EOS       
	
	mov DWORD PTR _Ptr,edx	; Save Int offset
        mov WORD PTR _Ptr[4],cx	; Save Int selector	
Endm

RestInt Macro Inter,_Ptr
        mov bl,Inter
        mov cx,WORD PTR _Ptr[4]
        mov edx,DWORD PTR _Ptr
       
        mov ah,Set_Int
        int_EOS
Endm

SetInt Macro Inter,Select,Offs
        mov bl,Inter
        mov cx,Select
        mov edx,Offset Offs
       
        mov ah,Set_Int
        int_EOS
Endm

GetIRQ Macro IRQ,_Ptr
	mov bl,IRQ
	mov ah,Get_Irq
	int_EOS

	mov DWORD PTR _Ptr,edx	; Save IRQ offset
        mov WORD PTR _Ptr[4],cx	; Save IRQ selector	
Endm

RestIRQ Macro IRQ,_Ptr
        mov bl,IRQ
        mov cx,WORD PTR _Ptr[4]
        mov edx,DWORD PTR _Ptr
       
        mov ah,Set_Irq
        int_EOS
Endm

SetIRQ Macro IRQ,Select,Offs
        mov bl,IRQ
        mov cx,Select
        mov edx,Offset Offs
       
        mov ah,Set_Irq
        int_EOS
Endm

Endif
; HARDWARE.INC (c) 1997 FreddyV/Useless