;            ͻ
;                LOADUTIL.ASM       
;                                                               
;                         Useless Loaders Utilities             
;            ĺ
;               By Freddy Vtel (FreddyV/Useless)              
;                                                               
;               Code starts .................. 06/04/1996       
;               Last update .................. 25/10/1996       
;            ͼ

.386

CODE32 SEGMENT PUBLIC PARA 'CODE' USE32
ASSUME  CS:CODE32,DS:CODE32,ES:CODE32

INCLUDE OS.INC
INCLUDE USS.INC
INCLUDE USSVAR.INC

INCLUDE LOADUTIL.INC
INCLUDE MEMORY.INC

INCLUDE UTILS.INC

;=============================================================================

MUS_File   DD 0
MUS_Offset DD 0
MUS_Channels DW 0

SOffset DD 0

;=============================================================================

;͸
; LU_LoadSample                                                           
;                                                                         
; Input: EDI Sample structure offset                                      
;                                                                         
; Output:                                                                 
;                                                                         
;

LU_LoadSample Proc
        Test SType[edi],SM_16Bit
	jz _LSNo16Bit

	mov eax,SLoop[edi]
	shr eax,1
	mov SLoop[edi],1
	mov eax,SLoopEnd[edi]
	shr eax,1
	mov SLoopEnd[edi],eax
	mov eax,SLength[edi]
	shr eax,1
	mov SLength[edi],eax

        mov eax,SLoop[edi]
        cmp eax,SLoopEnd[edi]
        jne _LSLoopNotEmpty16
        and SType[edi],Not SM_Loop
_LSLoopNotEmpty16:

	Test Stype[edi],SM_Loop
	Jz _LSLoopOk16
	
	mov eax,SLoopEnd[edi]
	cmp eax,SLength[edi]
	je _LSLoopOk16
	ja _LSAdjustLoopLen16
	inc eax
	mov SLength[edi],eax    ;Adjust Sample Length
	jmp _LSLoopOk16
_LSAdjustLoopLen16:	
	mov eax,SLength[edi]	;Adjust Loop Length
	mov SLoopEnd[edi],eax
_LSLoopOk16:
	mov eax,SLength[edi]
	shl eax,1
	
        ; ******* 16 bit Sample *******

	push eax
	Malloc eax              ;Allocate a buffer to load the sample.
	mov esi,eax
	mov Soffset,eax
	pop eax
	
	Mread esi,eax              ;Read sample data
	
	Test SType[edi],SM_Delta   ;Delta conversion ?
	jz   _NoDelta16

	xor eax,eax
	mov ecx,SLength[edi]
_Delta16Loop:                      ;Delta conversion Loop
	add ax,[esi]
	mov [esi],ax
	add esi,2
	dec ecx
	jnz _Delta16Loop

_NoDelta16:	

	and SType[edi],Not (SM_16Bit+SM_Delta)

	push edi	
	mov ecx,SLength[edi]
	mov esi,SOffset
	mov edi,esi
_8bitConvertLoop:		;8 bit conversion Loop
	lodsw
	mov [edi],ah
	inc edi
	dec ecx
	jnz _8bitConvertLoop
	pop edi
	
	;Appeler le loader de samples des drivers........
	
	mov esi,Soffset
	call USS_LoadSample	

	free Soffset		

	ret	
_LSNo16Bit:

	; *******  8 bit Sample *******	

        mov eax,SLoop[edi]
        cmp eax,SLoopEnd[edi]
        jne _LSLoopNotEmpty8
        and SType[edi],Not SM_Loop
_LSLoopNotEmpty8:		
		
	Test Stype[edi],SM_Loop
	Jz _LSLoopOk8
	
	mov eax,SLoopEnd[edi]
	cmp eax,SLength[edi]
	je _LSLoopOk8
	ja _LSAdjustLoopLen8
	inc eax			;to avoid loop click... ( On GUS )
	mov SLength[edi],eax    ;Adjust Sample Length (LoopEnd+1)
	jmp _LSLoopOk8
_LSAdjustLoopLen8:	
	mov eax,SLength[edi]	;Adjust Loop Length
	mov SLoopEnd[edi],eax
_LSLoopOk8:

	Malloc SLength[edi]     ;Allocate a buffer to load the sample.
	mov esi,eax
	mov Soffset,eax
	
	Mread esi,Slength[edi]  ;Read sample data

	Test SType[edi],SM_Delta ;Delta conversion ?
	jz   _NoDelta8
	
	xor eax,eax
	mov ecx,SLength[edi]
_Delta8Loop:                    ;Delta conversion Loop
	add al,[esi]
	mov [esi],al
	inc esi
	loop _Delta8Loop
        and SType[edi],Not SM_Delta

_NoDelta8:	
	;Appeler le loader de samples des drivers........
	
	mov esi,Soffset
	call USS_LoadSample		
	
	free Soffset	
	ret
LU_LoadSample Endp

CODE32 ENDS
;=============================================================================
end
; LOADUTIL.ASM (c) 1997 FreddyV/Useless