;            ͻ
;                 USMPLAY.ASM       
;                                                               
;                          Useless Module Player                
;            ĺ
;               By Freddy Vtel (FreddyV/Useless)              
;                                                               
;               Code starts .................. 09/08/1996       
;               Last update .................. 20/01/1997       
;            ͼ

.386

CODE32 SEGMENT PUBLIC PARA 'CODE' USE32
ASSUME CS:CODE32,DS:CODE32

INCLUDE OS.INC
INCLUDE SETUP.INC

INCLUDE USMPLAY.INC

INCLUDE USM.INC
INCLUDE USS.INC
INCLUDE USSVAR.INC

INCLUDE MEMORY.INC   ; Used by USMP_FreeModule

INCLUDE UTILS.INC

;-----------------------------------------------------------------------------

; ** Synchro var **  (They are public)

SynchroCount dd 0
Synchroval   db 0
MusicEnd     db 0

;-----------------------------------------------------------------------------

; ** Global player var **

USMOffset dd 0 ; USM header offset

USMFlags  dw 0 ; USM file flags

BPM       dd 0 ; Module Tempo ( 1193180*5/(2*BPM) )
BPMCnt    dd 0 ; Timer Ticks counter
Speed     db 0 ; Module Speed
SpeedCnt  db 0 ; Tempo counter
TickCnt   db 0 ; Tick counter

PatternOffset dd 0 ; Current Pattern Offset
RowOffset     dd 0 ; Current Note Offset

Order   dw 0    ; Current Order Pos
Pattern dw 0    ; Current Pattern
row     dw 0    ; Current row
rows    dw 0    ; Rows in current pattern

Patterndelay db 0
NextOrder    dw 0
Nextrow      dw 0

CInstr  dw 0    ; Current Instrument number
CNote   dw 0    ; Current Note
CVolume dw 0    ; Current Volume
CVComm  dw 0    ; Current Volume command
CVParam dw 0    ; Current Volume command parameter
CComm   dw 0    ; Current Command
CParam  dw 0    ; Current command parameter

Do_SetSampleDef  db 0 ; Set Channel volume to sample Volume ?

;-----------------------------------------------------------------------------

; ** Channels var **

MAX_CHANNELS EQU 32

ChInstrument   db MAX_CHANNELS DUP (0)  ;Channel Instrument
ChNote         db MAX_CHANNELS DUP (0)  ;Channel Note
ChCommande     db MAX_CHANNELS DUP (0)  ;Channel Command
ChVCommande    db MAX_CHANNELS DUP (0)  ;Channel Volume Command
ChVolume       db MAX_CHANNELS DUP (0)  ;Channel Volume
ChPeriod       dw MAX_CHANNELS DUP (0)  ;Channel Period
ChPanning      db MAX_CHANNELS DUP (0)  ;Channel Panning

ChRInstrument  db MAX_CHANNELS DUP (0)  ;Instrument of the current row
ChRNote        db MAX_CHANNELS DUP (0)  ;Note of the current row
ChRVolume      db MAX_CHANNELS DUP (0)  ;Volume of the current row

ChArpeggioData          db MAX_CHANNELS DUP (0) ; 00 Arpeggio
ChArpeggioPos           db MAX_CHANNELS DUP (0) ; 00 Arpeggio
ChPortaUpData           db MAX_CHANNELS DUP (0) ; 01 Portamento Up
ChPortaDownData         db MAX_CHANNELS DUP (0) ; 02 Portamento Down
ChPortaToNoteData       db MAX_CHANNELS DUP (0) ; 03 PortaToNote
ChPortaToNotePeriode    dw MAX_CHANNELS DUP (0) ; 03 PortaToNote
ChVibWave               db MAX_CHANNELS DUP (0) ; 04 Vibrato
ChVibSpeed              db MAX_CHANNELS DUP (0) ; 04 Vibrato
ChVibdepth              db MAX_CHANNELS DUP (0) ; 04 Vibrato
ChVibPos                db MAX_CHANNELS DUP (0) ; 04 Vibrato
ChTremWave              db MAX_CHANNELS DUP (0) ; 07 Tremolo
ChTremSpeed             db MAX_CHANNELS DUP (0) ; 07 Tremolo
ChTremdepth             db MAX_CHANNELS DUP (0) ; 07 Tremolo
ChTremPos               db MAX_CHANNELS DUP (0) ; 07 Tremolo
ChVolumeSlideData       db MAX_CHANNELS DUP (0) ; 10 Volume Slide

ChGVolumeSlideData      db MAX_CHANNELS DUP (0) ; 17 Global VolumeSlide
ChPanningSlideData      db MAX_CHANNELS DUP (0) ; 25 Panning Slide
ChMRetrigSpeed          db MAX_CHANNELS DUP (0) ; 27 Multi Retrig
ChMRetrigParam          db MAX_CHANNELS DUP (0) ; 27 Multi Retrig
ChMRetrigCnt            db MAX_CHANNELS DUP (0) ; 27 Multi Retrig
ChTremorPos             db MAX_CHANNELS DUP (0) ; 29 Tremor
ChTremorLen             db MAX_CHANNELS DUP (0) ; 29 Tremor
ChTremorOff             db MAX_CHANNELS DUP (0) ; 29 Tremor
ChFVolumeSlideUpData    db MAX_ChANNELS DUP (0) ; 46 Fine Volume Slide Up
ChFVolumeSlideDownData  db MAX_CHANNELS DUP (0) ; 47 Fine Volume Slide Down
ChEFPortaUData          db MAX_CHANNELS DUP (0) ; 33 Extra fine Portamento
ChEFPortaDData          db MAX_CHANNELS DUP (0) ; 33 Extra fine Portamento

ChFPortaUpData          db MAX_CHANNELS DUP (0) ; 37 Fine Portamento Up
ChFPortaDownData        db MAX_CHANNELS DUP (0) ; 38 Fine Portamento Down
ChPatLooprow            db MAX_CHANNELS DUP (0) ; 42 Pattern Loop
ChPatLoopCount          db MAX_CHANNELS DUP (0) ; 42 Pattern Loop

ChCommandeTick          db MAX_CHANNELS DUP (0) ; All 'Tick based' commands

ChVolCmdData            db MAX_CHANNELS DUP (0) ; Volume commands

;----------------------------------------------------------------------------



;=============================================================================

;͸
; USMP_LoadInternalModule: "Load" an internal USM file. (OBJ)             
;                                                                         
; Input: ESI USM Module Offset                                            
;                                                                         
; Output: --                                                              
;                                                                         
;

USMP_LoadInternalModule Proc

; ** Move the data pointers **

	xor ecx,ecx
	mov eax,esi
MovePointersLoop:        
	cmp MPattPtr[esi+4*ecx],0
	je NotMovePointer
	add MPattPtr[esi+4*ecx],eax
NotMovePointer:

	inc cx
	cmp ecx,MAX_Patterns+MAX_Samples+MAX_Instruments
	jne MovePointersLoop

; ** "Load" samples data **

	xor ecx,ecx     
LoadSamplesLoop:
	mov edi,MSamplPtr[esi+4*ecx]
	cmp edi,0
	je NotLoadSample

	test SType[edi],SM_Loaded    ; Is sample data in the file ?
	jz NotLoadSample
	and SType[edi],Not SM_Loaded ; Sample data is not in memory
		
	mov esi,SPointer[edi]
	add esi,eax
	
	pushad
	mov ecx,SLength[edi]
	xor eax,eax
_DeltaLoop:
	add al,[esi]
	mov [esi],al
	inc esi
	loop _DeltaLoop
	and SType[edi],Not SM_Delta
	popad
		
	pushad
	call USS_LoadSample
	popad
NotLoadSample:

	mov esi,eax
	inc cx
	cmp cx,MSamples[esi]
	jne LoadSamplesLoop
	
	ret
USMP_LoadInternalModule Endp

;͸
; USMP_FreeModule: Remove a module from memory                            
;                                                                         
; Input: ESI USM Module Offset                                            
;                                                                         
; Output: --                                                              
;                                                                         
;
if UseFreeModule eq Yes

USMP_FreeModule Proc
	mov USMOffset,esi
	
; ** Free the module patterns **
	xor ecx,ecx
FreePatternsLoop:
	mov eax,MPattPtr[esi+4*ecx]
	or eax,eax
	jz FreePatternsSkip
	push ecx
	Free eax
	pop ecx
FreePatternsSkip:       
	inc ecx
	cmp ecx,MAX_Patterns
	jne FreePatternsLoop
	
; ** Free the module instruments **
	mov esi,USMOffset
	xor ecx,ecx
FreeInstrumentsLoop:
	mov eax,MInstrPtr[esi+4*ecx]
	or eax,eax
	jz FreeInstrumentSkip
	push ecx
	Free eax
	pop ecx
FreeInstrumentSkip:     
	inc ecx
	cmp ecx,MAX_Instruments
	jne FreeInstrumentsLoop

; ** Free the module samples **
	mov esi,USMOffset
	xor ecx,ecx
FreeSamplesLoop:
        mov eax,MSamplPtr[esi+4*ecx]
	or eax,eax
	jz FreeSampleSkip
        push ecx

	push eax            
	mov edi,eax
	call USS_FreeSample ; ** Free Sample data **
	pop eax
	Free eax            ; ** Free sample definition **

	pop ecx
FreeSampleSkip: 
	inc ecx
	cmp ecx,MAX_Samples
	jne FreeSamplesLoop

; ** Free the module header **
	Free USMOffset

	clc
	ret 
USMP_FreeModule Endp

Endif

;͸
; USMP_StartPlay                                                          
;                                                                         
; Input: ESI USM Module Offset                                            
;                                                                         
; Output: --                                                              
;                                                                         
;
USMP_StartPlay Proc

;       writeln 'Lancement du module...'
;       waitkey
	push esi
	call USS_InitVar        
	pop esi
	
	mov USMOffset,esi
	mov ax,MFlags[esi]
        mov USMFlags,ax

; Instruments and samples tables offset
        mov eax,esi
	add eax,MSamplPtr
	mov SSSAmpleOffsetT,eax
	add eax,MInstrPtr-MSamplPtr
	mov SSInstrOffsetT,eax

; Linear/Log Period
	mov SSLinearPeriode,0
	test Mflags[esi],F_Linear
	jz NoLinearPeriode
	mov SSLinearPeriode,1
NoLinearPeriode:

; Sample/Instrument Mode
	mov SSInstrumentMode,0
	test Mflags[esi],F_InstrMode
	jz NoInstrumentMode
	mov SSInstrumentMode,1
NoInstrumentMode:       
	
	
	mov BPMCnt,0
	xor eax,eax
	mov al,MBPM[esi]
	call ProcSetBPM              ; Set Initial BPM
	mov al,MTempo[esi]
	mov Speed,al                 ; Set Initial Speed        
	dec al
	mov SpeedCnt,al

        mov al,64                    ; !!! A Changer !!!
	call USS_SetGlobalVolume

	xor eax,eax
	xor ebp,ebp
SetStartPanningLoop:    
	mov al,MChPan[esi+ebp]
	call USS_SetPanning
	inc ebp
	cmp ebp,32
	jne SetStartPanningLoop

	mov Patterndelay,0
	mov NextOrder,0
	mov NextRow,0
	mov MusicEnd,0

; Start the sound output

	movzx eax,MChannels[esi]
	mov esi,Offset USMP_PeriodicProc
	call USS_StartOutput

	ret
USMP_StartPlay Endp

;͸
; USMP_StopPlay                                                           
;                                                                         
; Input: ESI USM Module Offset                                            
;                                                                         
; Output: --                                                              
;                                                                         
;
USMP_StopPlay Proc

	call USS_StopOutput
	
	ret
USMP_StopPlay Endp

;͸
; USMP_PrevOrder: Go to next music pattern.                               
;                                                                         
; Input: --                                                               
;                                                                         
; Output: --                                                              
;                                                                         
;
USMP_PrevOrder Proc
        mov ax,Order
        dec ax
        js SkipPrevOrder
        mov NextOrder,ax
        mov Nextrow,0
SkipPrevOrder:        
        ret
USMP_PrevOrder Endp

;͸
; USMP_NextOrder: Go to previous music pattern.                           
;                                                                         
; Input: --                                                               
;                                                                         
; Output: --                                                              
;                                                                         
;
USMP_NextOrder Proc
        mov ax,Order
        inc ax
        
        mov esi,USMOffset
        cmp ax,MSongLen[esi]
        je SkipNextOrder
        mov NextOrder,ax
        mov Nextrow,0
SkipNextOrder:
        ret
USMP_NextOrder Endp

;͸
; USMP_SetOrder                                                           
;                                                                         
; Input: AX New order.                                                    
;                                                                         
; Output: --                                                              
;                                                                         
;
USMP_SetOrder Proc
        mov esi,USMOffset
        cmp ax,MSongLen[esi]
        jae SkipSetOrder
        mov NextOrder,ax
        mov Nextrow,0
SkipSetOrder:
        ret
USMP_SetOrder Endp


;***************************************************************
;********************  Internal functions **********************
;***************************************************************

USMP_PeriodicProc proc
	push ebp
	
	add BPMCnt,eax
BPMLoop:
	mov eax,BPM
	cmp BPMCnt,eax
	jb  NoProcess
	sub BPMCnt,eax

        call PlayerTick      ; Process the next row or effect.
	call USS_UpdateInstr ; Do the instruments envelopes and Auto vibrato.
	
        jmp BPMLoop
NoProcess:              

	call USS_UpdateOutput
 
	pop ebp 
	ret
USMP_PeriodicProc Endp

;͸
; PlayerTick: Process a pattern change, a row or an effect.               
;                                                                         
;
PlayerTick Proc

; ** Process Speed **

	inc SpeedCnt            
	mov al,Speed
	cmp SpeedCnt,al
	jne DoEffects
	mov SpeedCnt,0

	mov TickCnt,0

; ** Process Pattern delay and music order **

	cmp Patterndelay,0   ; * Pattern delay command *
	je  NoPatterndelay
	dec Patterndelay
	jmp DoEffects        ; Do not process the row => Delay the pattern.
NoPatterndelay: 
	
	cmp NextOrder,-1     ; A pattern break or jump pattern command occurs
	jne ChangeOrder      ; => Jump to the needed order

	mov ax,row
	cmp ax,rows          ; If actual row is pattern length,
	jb  NotChangeOrder

	mov NextRow,0        ; jump to the next order (with Row=0)
	movzx eax,Order
	inc eax
	mov NextOrder,ax     ; Next order is actual order+1

ChangeOrder:    
	call DoChangeOrder   ; Change Order number.

NotChangeOrder:
	cmp Nextrow,-1
	je  NotChangerow
	call DoChangeRow     ; Change Row number.
NotChangeRow:   

; ** Process row **

	call ProcRow
	
; ** Go to next row ** 
        inc row
	ret

DoEffects:

	inc TickCnt

	xor ebp,ebp
DoEffectsLoop:  

	movzx edx,ChVCommande[ebp]
	cmp edx,10
	jae NoDoVCmd
	call Dovoltable[4*edx]
NoDoVCmd:

	movzx edx,ChCommande[ebp]
	cmp edx,52
	jae NoDoCmd
	call Docmdtable[4*edx]  
NoDoCmd:

	inc ebp
	cmp ebp,SSActiveChannels
	jne DoEffectsLoop
	
	ret
PlayerTick Endp

;͸
; ProcRow: Process one pattern Row.                                       
;                                                                         
;

ProcRow proc
		
	mov ebp,0
ChannelLoop:

; ** Read Channel datas **

	mov CvComm,0FFh
	mov esi,RowOffset
	add RowOffset,5
	
	movzx eax,byte ptr [esi]
	mov CNote,ax
	mov ChRNote[ebp],al
        movzx eax,byte ptr [esi+1]
	mov CInstr,ax   
        mov ChRInstrument[ebp],al
        movzx eax,byte ptr [esi+2]
	mov CVolume,ax
	
        movzx eax,byte ptr [esi+4]
	mov CParam,ax
	movzx eax,byte ptr [esi+3]

; If No Arpeggio, set CCom to 0FFh
	cmp eax,0
	jne TstArp
	cmp CParam,0
	jne TstArp
	mov al,0FFh
TstArp: 
	mov CComm,ax      

; ** Get Volume command value **

	cmp CVolume,50h
	jbe No_VolCmd
        mov ax,CVolume    ; Volume>=50h => Volume command
        mov CVolume,0
        sub ax,60h
	mov bx,ax
	shr ax,4
	mov CVComm,ax
        and bx,0Fh
	mov CVParam,bx
No_VolCmd:
        mov ax,CVolume
        mov ChRVolume[ebp],al

; ** Restore the period (after an arpeggio or a vibrato) 

        mov ax,CComm
	cmp ChCommande[ebp],al ; If actual command is previous command 
	je  NoRestorePeriod    ; don't restore the period.

        call USS_GetPeriod
	cmp ax,ChPeriod[2*ebp]
	je  NoRestorePeriod
	mov ax,ChPeriod[2*ebp]
	call USS_SetPeriod
NoRestorePeriod:

; ** Start a new note if there is no Note Delay **

        cmp CComm,49    ; Delay Note => Do not Start sound !
	je NoStartNote

        call StartNote

NoStartNote:        

;                  *** Process Volume command ***

	movzx edx,CVComm
        movzx eax,CVParam
	mov ChVCommande[ebp],dl 
	cmp edx,10
	jae NoProcVCmd
        call Procvoltable[4*edx] ; Call command
NoProcVCmd:                             

;                     *** Process Command ***
	
	movzx eax,CParam
	movzx edx,CComm
	mov ChCommande[ebp],dl  
	cmp edx,52
	jae NoProcCmd
	call Proccmdtable[4*edx] ; Call Command
NoProcCmd:

; ** Loop to the next channel **	
	mov esi,USMOffset
	inc ebp                  ; Next channel
	cmp bp,MChannels[esi]
	jne ChannelLoop          ; Loop
	
	ret
Procrow endp

;͸
; StartNote:                                                              
;                                                                         
;

StartNote Proc
	mov Do_SetSampleDef,0

; ** Instrument **

	cmp CInstr,0
	je NoInstrument
	
        mov ax,CInstr
	mov ChInstrument[ebp],al ; Set new Instrument number.

; Now, retrig all needed  commands and values.
; (As it was not done in mxm play)

        call USS_InitInstrEnv    ; Retrig instrument envelopes.
        
        mov Do_SetSampleDef,1	 ; Set Volume and Panning to Sample values.
        mov ChTremorPos[ebp],0   ; Retrig Tremor
        mov ChMRetrigCnt[ebp],0  ; Clear multi retrig counter.

	cmp ChVibWave[ebp],4
	jae NoRetrigVib         
	mov ChVibPos[ebp],0      ; Retrig Vibrato
NoRetrigVib:
	cmp ChTremWave[ebp],4
	jae NoRetrigTrem
	mov ChTremPos[ebp],0     ; Retrig Tremolo
NoRetrigTrem:

NoInstrument:

; ** Note and Start Instrument **

	cmp CNote,255
	jne CheckNote
	call USS_KeyOff
	mov CNote,0
CheckNote:

	cmp CNote,0
	je  NoNote
	
;       dwrite ' Note: '
;       movzx eax,CNote
;       call _dprint_dec
	
	cmp CComm,3     ; Portamento to note
	je  NoNote
	cmp CVComm,9    ; 'Volume' Portamento to note
	je  NoNote

	xor ebx,ebx
	mov bx,CNote
	mov ChNote[ebp],bl

	xor eax,eax
	mov al,ChInstrument[ebp]
	call StartInstrument
	jnc  NoNote
	mov ChInstrument[ebp],0
NoNote: 

; ** Set Sample default values (Volume/Panning)  **
; *  It's done when an instrument number is set.  *


        call USS_GetSample
	or esi,esi
	jz NoSetPanning        ; If there is no sample, skip this part

	cmp Do_SetSampleDef,0  ; Set Sample Default values ?
	je NoSetPanning

	movzx eax,SVolume[esi] ; Read sample volume.
        
	mov ChVolume[ebp],al   ; Channel volume is sample volume.
	call USS_SetVolume
NoSetSampleVol: 

	test USMFlags,F_SetPann ; Set default panning only with XM files.
	jz NoSetPanning

	mov al,SPanning[esi]   ; Read sample panning.

        mov ChPanning[ebp],al  ; Channel panning is sample panning.
        call USS_SetPanning
NoSetPanning:

; ** Volume **

	cmp CVolume,0
	je  NoVolume
	sub CVolume,10h
	mov ax,CVolume
	mov ChVolume[ebp],al
	call USS_SetVolume
NoVolume:
        ret
StartNote Endp

StartInstrument Proc 
	cmp eax,0
	je  StartInstrumentEnd
	dec eax
	call USS_StartInstrument
	call USS_GetPeriod
	mov ChPeriod[2*ebp],ax
StartInstrumentEnd:     
	ret
StartInstrument Endp

;͸
; DoChangeOrder: Changes the current Order                                
;                                                                         
;

DoChangeOrder proc
	movzx eax,NextOrder
	mov esi,USMOffset

	cmp ax,MSongLen[esi]
	jb  SongLengthOk
	mov MusicEnd,1
	mov ax,MRestart[esi] ;Loop the song
SongLengthOk:
	mov Order,ax

	mov al,MOrder[esi+eax]  
	mov eax,MPattPtr[esi+4*eax]
	cmp eax,0
	jne PatternNotEmpty
	inc NextOrder           ; Pattern Empty => go to next pattern
	jmp DoChangeOrder
PatternNotEmpty:        
	mov PatternOffset,eax
	mov bx,Prow[eax]
	mov rows,bx
	
	mov NextOrder,-1        ; Reset order value
	ret
DoChangeOrder endp      

;͸
; DoChangerow: Changes the current Row                                    
;                                                                         
;

DoChangeRow proc
	movzx eax,NextRow
	mov row,ax
	lea eax,[eax+4*eax]     ; eax <- eax*5
	mov esi,USMOffset
	mov bx,MChannels[esi]
	mul bx                  ; eax <- 5*eax*Channels
	add eax,PatternOffset
	add eax,USMPatternSize
	mov RowOffset,eax

        mov NextRow,-1          ; Reset row value
	ret
DoChangeRow Endp

;                     ** Commands processing **

;͸
;o                          Process Nothing                               
;                                                                         
;
ProcNothing proc
	ret
ProcNothing endp

;͸
;o                       Process Set BPM command                          
;                                                                         
;
ProcSetBPM proc
	xor ebx,ebx
	mov bl,al
	shl bx,1
	xor edx,edx
	mov eax,1193180*5
	div ebx
	mov BPM,eax
	ret
ProcSetBPM endp

;͸
;o                     Process Set Tempo command                          
;                                                                         
;
ProcSetTempo proc   
        cmp al,20h      ; If Speed>20h, Set BPM
	jb SetTempo     
	jmp ProcSetBPM  
SetTempo:       
	mov Speed,al
	ret
ProcSetTempo endp

;͸
;o                      Process Arpeggio command                          
;                                                                         
;
ProcArpeggio proc
	cmp al,0
	je NoArpeggio
	mov ChArpeggioData[ebp],al
	mov ChArpeggioPos[ebp],0
	jmp DoArpeggio
NoArpeggio:     
	mov ChCommande[ebp],0FFh
	ret
ProcArpeggio endp

;͸
;o                     Process Portamento Up command                      
;                                                                         
;
ProcPortup proc
	cmp al,0
	je ProcPortupEnd
	mov ChPortaUpData[ebp],al
ProcPortUpEnd:  
	ret
ProcPortup endp

;͸
;o                    Process Portamento Down command                     
;                                                                         
;
ProcPortdown proc
	cmp al,0
	je ProcPortdownEnd
	mov ChPortaDownData[ebp],al
ProcPortDownEnd:
	ret
ProcPortdown endp

;͸
;o                     Process Porta To Note command                      
;                                                                         
;
ProcPortanote proc
	cmp al,0
	je ProcPortanoteNext
	mov ChPortaToNoteData[ebp],al
ProcPortanoteNext:
	cmp CNote,0
	je ProcPortanoteEnd
        call USS_GetSample   ; Get Sample adress in esi
	mov bx,CNote                
	call Get_NotePeriod  ; Get the period from the note and the sample @
	mov ChPortaToNotePeriode[2*ebp],ax
ProcPortanoteEnd:       
	ret
ProcPortanote endp

;͸
;o                        Process Vibrato command                         
;                                                                         
;
; Note: Vibrato is retrig at Instrument start

ProcVibrato proc 
	mov bl,al
	test al,0F0h
	jz NoVibSpeed
	shr bl,4
        shl bl,2
	mov ChVibSpeed[ebp],bl
NoVibSpeed:     
	test al,0Fh
	jz NoVibDepth
	and al,0Fh
	mov ChVibdepth[ebp],al
NoVibDepth:     
	ret
ProcVibrato endp

;͸
;o                        Process Tremolo command                         
;                                                                         
;
; Note: Tremolo is Retrig at Instrument start

ProcTremolo proc
	mov bl,al
	test al,0F0h
	jz NoTremSpeed
        shr bl,4
        shl bl,2
        mov ChTremSpeed[ebp],bl
NoTremSpeed:    
	test al,0Fh
	jz NoTremDepth
	and al,0Fh
	mov ChTremdepth[ebp],al
NoTremDepth:    
	ret
ProcTremolo endp

;͸
;o                      Process Set Panning command                       
;                                                                         
;
ProcSetPanning1 proc
	call USS_SetPanning
	ret
ProcSetPanning1 endp

;͸
;o                     Process Set Panning command                        
;                                                                         
;
ProcSetpanning2 proc
	shl al,4
	call USS_SetPanning
	ret
ProcSetPanning2 endp

;͸
;o                  Process Sample Offset command                         
;                                                                         
;
ProcSetOffset proc
	shl ax,8
	call USS_SetSampleOffset
	ret
ProcSetOffset Endp

;͸
;o                   Process Volume Slide command                         
;                                                                         
;
ProcVolumeSlide proc
	cmp al,0
	je  ProcVSEnd
	mov ChVolumeSlideData[ebp],al
ProcVSEnd:      
	ret
ProcVolumeSlide endp

;͸
;o                   Process Jump Pattern command                         
;                                                                         
;
ProcJump proc
	mov NextOrder,ax  ; Jump to 'Param' Order and row 0
	mov Nextrow,0      
	ret
ProcJump endp

;͸
;o                    Process Set Volume command                          
;                                                                         
;
ProcSetVolume proc
	mov ChVolume[ebp],al
	call USS_SetVolume
	ret
ProcSetVolume endp

;͸
;o                   Process Pattern Break command                        
;                                                                         
;
ProcBreak proc
	cmp NextOrder,-1
	jne ChangeRow
	movzx ebx,Order
	inc ebx
	mov NextOrder,bx
ChangeRow:      
	mov ebx,eax
	shr eax,4
	imul eax,10
	and bl,0Fh
	add eax,ebx
	mov NextRow,ax
	ret
ProcBreak endp

;͸
;o               Process Set Global Volume command                        
;                                                                         
;
ProcGVolume proc
	call USS_SetGlobalVolume
	ret
ProcGVolume endp

;͸
;o                  Process Global Volume Slide command                   
;                                                                         
;
ProcGVolumeSlide proc
	cmp al,0
	je ProcGVolumeSlideEnd
	mov ChGVolumeSlideData[ebp],al
ProcGVolumeSlideEnd:
	ret
ProcGVolumeSlide endp

;͸
;o                     Process Tick based commands                        
;                                                                         
;
ProcTick proc
	mov ChCommandeTick[ebp],al
	movzx edx,CComm
	call Docmdtable[4*edx]     ; Call for Tick 0    
	ret
ProcTick endp

;͸
;x                   Process Set Envelope Pos command                     
;                                                                         
;
ProcEnvPos proc
	ret
ProcEnvPos endp

;͸
;o                  Process Pannig slide command                          
;                                                                         
;
ProcPanningSlide proc
	cmp al,0
	je ProcPanningSlideEnd
	mov ChPanningSlideData[ebp],al
ProcPanningSlideEnd:    
	ret
ProcPanningSlide endp

;͸
;o                   Process Multi Retrig command                         
;                                                                         
;
; Note: Multi Retrig counter is clear at Instrument start

ProcMRetrig proc
        mov bl,al
	test al,0F0h
	jz NoMRetParam
	shr bl,4
	mov ChMRetrigParam[ebp],bl
NoMRetParam:    
	test al,0Fh
	jz NoMRetSpeed
	and al,0Fh
	mov ChMRetrigSpeed[ebp],al
NoMRetSpeed:    
        call DoMRetrig   ; Do Multi Retrig at Tick 0
	ret
ProcMRetrig endp        

;͸
;o                     Process Tremor command                             
;                                                                         
;
; Note: Tremor is Retrig at Instrument start
;       It's played as FT2 does, ST3 plays it differently.
;       FT2 was supposed to emulate ST Tremor, It's really strange.....
;       Anyway, it's one of the most buggy FT2 effect.

ProcTremor proc
        cmp al,0
        je ProcTremorEnd
        shl eax,4
        shr al,4
        inc ah
        inc al
        add al,ah
        mov ChTremorLen[ebp],al
        mov ChTremorOff[ebp],ah       
ProcTremorEnd:        
        ret
ProcTremor endp

;͸
;o               Process Extra fine portamento command                    
;                                                                         
;
ProcEFPort proc
        shl eax,4
        shr al,4
        cmp ah,1
        je EFPortUp
        cmp ah,2
        jne ProcEFPortEnd

        cmp al,0
        je EFPortDPrevData
        mov ChEFPortaDData[ebp],al
EFPortDPrevData:
	movzx eax,ChEFPortaDData[ebp]
	add ax,ChPeriod[2*ebp]

	call USS_SetPeriod        
        mov ChPeriod[2*ebp],ax
        ret
        
EFPortUp:
        cmp al,0
        je EFPortUPrevData
        mov ChEFPortaUData[ebp],al
EFPortUPrevData:
	movzx ebx,ChEFPortaUData[ebp]
	movzx eax,ChPeriod[2*ebp]
	sub eax,ebx
_EFTooLow:        

	call USS_SetPeriod
        mov ChPeriod[2*ebp],ax
ProcEFPortEnd:
	ret
ProcEFPort endp 

;͸
;o                Process Fine Portamento Up command                      
;                                                                         
;
ProcFPortup proc
	cmp al,0
	je ProcFPortupEnd
	mov ChFPortaUpData[ebp],al
ProcFPortUpEnd: 
	movzx ebx,ChFPortaUpData[ebp]
	shl ebx,2
	movzx eax,ChPeriod[2*ebp]
	sub eax,ebx
	call USS_SetPeriod 
	mov ChPeriod[2*ebp],ax
        ret
ProcFPortup endp

;͸
;o                Process Fine Portamento Down command                    
;                                                                         
;
ProcFPortdown proc
	cmp al,0
	je ProcFPortdownEnd
	mov ChFPortaDownData[ebp],al
ProcFPortDownEnd:
	movzx eax,ChFPortaDownData[ebp]
	shl eax,2
	add ax,ChPeriod[2*ebp]
	call USS_SetPeriod
	mov ChPeriod[2*ebp],ax
        ret
ProcFPortdown endp

;͸
;x                 Process Glissando Control command                      
;                                                                         
;
Procgliss proc
	ret
Procgliss endp

;͸
;o                Process Vibrato Type command                            
;                                                                         
;
Procvibtype proc
	mov ChVibWave[ebp],al
	ret
Procvibtype endp

;͸
;o                 Process Pattern Loop command                           
;                                                                         
;
Procpatloop proc
        or al,al
        jz SetLoopStart
        inc al
        cmp ChPatLoopCount[ebp],0
        jne Not_First_Loop
        mov ChPatLoopCount[ebp],al
Not_First_Loop:
        dec ChPatLoopCount[ebp]
        jz ProcPatLoopEnd
        mov al,ChPatLoopRow[ebp]
        mov NextRow,ax
        mov ax,Order
        mov NextOrder,ax
        ret
SetLoopStart:
        mov ax,row
        mov ChPatLoopRow[ebp],al
ProcPatLoopEnd:
        ret
Procpatloop endp

;͸
;o                 Process Tremolo Type command                           
;                                                                         
;
Proctremtype proc
	mov ChTremWave[ebp],al
	ret
Proctremtype endp

;͸
;o                 ProcessFine Volume Up command                          
;                                                                         
;
ProcFVolumeUp proc
	cmp al,0
	je  ProcFVSlideUpEnd
	mov ChFVolumeSlideUpData[ebp],al
ProcFVSlideUpEnd:       
	mov al,ChVolume[ebp]
	mov bl,ChFVolumeSlideUpData[ebp]
	add al,bl
	cmp al,40h
	jbe DoFVSUpOk
	mov al,40h
DoFVSUpOk:
	mov ChVolume[ebp],al
	call USS_SetVolume
	ret
ProcFVolumeUp endp

;͸
;o                 Process Fine Volume Down command                       
;                                                                         
;
ProcfVolumedn proc
	cmp al,0
	je  ProcFVSlideDownEnd
	mov ChFVolumeSlideDownData[ebp],al
ProcFVSlideDownEnd:     
	mov al,ChVolume[ebp]
	mov bl,ChFVolumeSlideDownData[ebp]
	sub al,bl
	jnc DoFVSDownOk
	mov al,0
DoFVSDownOk:
	mov ChVolume[ebp],al
	call USS_SetVolume
	ret
ProcfVolumedn endp

;͸
;o                 Process Pattern Delay command                          
;                                                                         
;
ProcPatternDelay proc
	mov PatternDelay,al
	ret
ProcPatternDelay endp

ProcSynchro proc
	mov Synchroval,al
	inc Synchrocount
	ret
ProcSynchro endp

;                  **** Command tick procedures ****

;͸
;o                       Do Arpeggio command                              
;                                                                         
;
DoArpeggio proc 
        movzx eax,ChNote[ebp]
        movzx ecx,ChArpeggioPos[ebp]
        mov bl,ChArpeggioData[ebp]
        cmp cl,0
        je DoArpeggioSN
        cmp cl,1
        jne DoArpeggio2
        shr bl,4
        add al,bl
        jmp DoArpeggioSN
DoArpeggio2:    
        and bl,0Fh
        add al,bl
DoArpeggioSN:   
        call USS_SetNote
        inc cl
        cmp cl,3
        jne DoArpeggioEnd
        mov cl,0
DoArpeggioEnd:
        mov ChArpeggioPos[ebp],cl
        ret
DoArpeggio Endp

;͸
;o                     Do Portamento Up command                           
;                                                                         
;
DoPortamentoUp proc
        movzx ebx,ChPortaUpData[ebp]
        shl ebx,2
        movzx eax,ChPeriod[2*ebp]
        sub eax,ebx
        call USS_SetPeriod
        mov ChPeriod[2*ebp],ax
        ret
DoPortamentoUp Endp

;͸
;o                     Do Portamento Down command                         
;                                                                         
;
DoPortamentoDown proc
        movzx eax,ChPortaDownData[ebp]
        shl eax,2
        add ax,ChPeriod[2*ebp]
        call USS_SetPeriod
        mov ChPeriod[2*ebp],ax
        ret
DoPortamentoDown Endp

;͸
;o                       Do Porta to note command                         
;                                                                         
;
DoPortanote proc
        xor ecx,ecx
        xor eax,eax
        movzx bx,ChPortaToNoteData[ebp]
        shl bx,2
        mov ax,ChPeriod[2*ebp]
        mov cx,ChPortaToNotePeriode[2*ebp]

        cmp cx,0
        je DoPortaNoteEnd
        cmp ax,cx
        ja  DoPortaU
        je  DoPortanoteEnd
        add ax,bx
        cmp ax,cx
        jbe DoPortanoteOk
        mov ax,cx       
DoPortaU:
        cmp ax,bx
        ja  DoPortaUOk
        mov ax,cx
        jmp DoPortaNoteOk
DoPortaUOk:
        sub ax,bx
        cmp ax,cx
        jae DoPortaNoteOk
        mov ax,cx       
DoPortaNoteOk:
        call USS_SetPeriod
        mov ChPeriod[2*ebp],ax
DoPortaNoteEnd: 
        ret
DoPortanote Endp

;͸
;o                         Do Vibrato command                             
;                                                                         
;
DoVibrato proc
        mov ch,ChVibSpeed[ebp]
        mov cl,ChVibWave[ebp]
        and cl,3
        movzx edx,ChVibdepth[ebp]
        movzx ebx,ChVibPos[ebp]
        call GetVibData            ; Get Vibrato data
        sar cx,5                   ; Not 7, because periode is 4 times bigger
        mov ChVibPos[ebp],bl
        mov ax,ChPeriod[2*ebp]

        add ax,cx
        call USS_SetPeriod
        ret
DoVibrato endp

;͸
;o               Do Porta To Note+Volume Slide command                    
;                                                                         
;
Doportvol proc
        call DoVolumeSlide  ; Do Volume slide
        jmp  DoPortanote    ; Do Porta to note
Doportvol Endp

;͸
;o                  Do Vibrato+Volume Slide command                       
;                                                                         
;
Dovibvol proc
        call DoVolumeSlide
        jmp  DoVibrato
Dovibvol endp

;͸
;o                         Do Tremolo command                             
;                                                                         
;
Dotremolo proc
        mov ch,ChTremSpeed[ebp]
        mov cl,ChTremWave[ebp]
        and cl,3
        movzx dx,ChTremdepth[ebp]
        movzx ebx,ChTremPos[ebp]
        call GetVibData            ; Get Tremolo data
        sar cx,6                   
        mov ChTremPos[ebp],bl
        mov al,ChVolume[ebp]
        or cx,cx
        js _TDNeg
        add al,cl
        cmp al,40h
        jbe DoTremEnd
        mov al,40h
        jmp DoTremEnd
_TDNeg:
        add al,cl
        cmp al,40h
        jbe DoTremEnd
        xor eax,eax
DoTremEnd:
        call USS_SetVolume
        ret
Dotremolo Endp

;͸
;o                     Do Volume Slide command                            
;                                                                         
;
Dovolumeslide proc   
        mov al,ChVolume[ebp]
        mov bl,ChVolumeSlideData[ebp]
        test bl,0F0h
        jnz GVSUp
        sub al,bl
        jnc GVSEnd
        xor al,al
        jmp GVSEnd
GVSUp: 
        shr bl,4
        add al,bl       
        cmp al,40h
        jbe GVSEnd
        mov al,40h
GVSEnd:
        mov ChVolume[ebp],al
        call USS_SetVolume
        ret
DoVolumeSlide Endp

;͸
;o                  Do Global VolumeSlide command                         
;                                                                         
;
DoGvolumeslide proc
        movzx eax,SSGlobalVol
        mov bl,ChGVolumeSlideData[ebp]
        test bl,0F0h
        jnz VSUp
        sub al,bl
        jnc VSEnd
        xor al,al
        jmp VSEnd
VSUp:   
        shr bl,4
        add al,bl       ; Do not test if volume>40h, it's done in SetGlobalVol
VSEnd:
	call USS_SetGlobalVolume
	ret
DoGvolumeslide endp

;͸
;o                       Do Key Off command                               
;                                                                         
;
Dokeyoff proc
        mov al,ChCommandeTick[ebp]
        cmp al,TickCnt
        jne DoKeyOffEnd
        call USS_KeyOff
DoKeyOffEnd:    
        ret
DoKeyoff endp

;͸
;o                    Do Panning Slide command                            
;                                                                         
;
DoPanningSlide proc
        call USS_GetPanning
        mov bl,ChPanningSlideData[ebp]
        test bl,0F0h
        jnz PSRight
        sub al,bl
        jnc PSEnd
        xor al,al
        jmp PSEnd
PSRight:        
        shr bl,4
        add al,bl       
        jnc PSEnd
        mov al,0FFh
PSEnd:
        call USS_SetPanning
        ret
DoPanningSlide Endp

;͸
;o                      Do Multi Retrig command                           
;                                                                         
;
DomRetrig proc
        mov bl,ChMRetrigSpeed[ebp]
        inc ChMRetrigCnt[ebp]
        cmp bl,ChMRetrigCnt[ebp]
        jne NotmRetrig
        mov ChMRetrigCnt[ebp],0
; Retrig the sample
        xor eax,eax
        call USS_SetSampleOffset   ; Sample Offset=0

; Now, Change the channel volume
        movzx eax,ChVolume[ebp]
        mov cl,ChMRetrigParam[ebp]

        cmp cl,8
        ja  MR_Up
        je NotmRetrig
        or cl,cl
        jz NotmRetrig

        cmp cl,6
        jae MR_Div

; Volume-(2^(cl-1))
        dec cl
        mov bl,1
        shl bl,cl
        sub al,bl
        jns mRetrigEnd
        mov al,0
        jmp mRetrigEnd

MR_Div:
        jne MR_Div2
; 6 => Volume*2/3       
        shl al,1
        mov bl,3
        div bl
        jmp mRetrigEnd
MR_Div2:
; 7 => Volume*1/2
        shr al,1
        jmp mRetrigEnd 
	
MR_Up:
        cmp cl,0Eh
        jae MR_Mul

; Volume+(2^(cl-9))
        sub cl,9
        mov bl,1
        shl bl,cl
        add al,bl
        jmp mRetrigCutHighVolume
MR_Mul:
        jne MR_Mul2
; E => Volume*3/2

        mov ah,al
        shl al,1
        add al,ah
        shr al,1
        jmp mRetrigCutHighVolume
MR_Mul2:
; F => Volume*2

        shl al,1

mRetrigCutHighVolume:
        cmp al,40h
        jbe mRetrigEnd
        mov al,40h
mRetrigEnd:

        mov ChVolume[ebp],al
        call USS_SetVolume
NotmRetrig:     
        ret
DomRetrig Endp

;͸
;o                         Do Tremor command                              
;                                                                         
;
Dotremor proc
        mov bl,ChTremorPos[ebp]
        mov al,ChVolume[ebp]
        cmp bl,ChTremorOff[ebp]
        jb  TremorOn
        xor al,al
TremorOn:
        inc bl
        cmp bl,ChTremorLen[ebp]
        jb  Tremor_ChangeVolume
        xor bl,bl
Tremor_ChangeVolume:
        mov ChTremorPos[ebp],bl
        call USS_SetVolume      ; Set new volume (0 or Channel volume)
        ret                     ; It only affect the sound system volume.
Dotremor Endp

;͸
;o                        Do Retrig command                               
;                                                                         
;
Doretrig proc
        movzx ax,TickCnt
        cmp al,ChCommandeTick[ebp]
        je _Doretrig

        cmp ax,0
        je NotRetrig
        cmp ChCommandeTick[ebp],0
        je NotRetrig

        div ChCommandeTick[ebp]
        cmp ah,0
        jne NotRetrig
_Doretrig:
        xor eax,eax
        call USS_SetSampleOffset
NotRetrig:      
        ret
Doretrig Endp

;͸
;o                      Do Note Cut command                               
;                                                                         
;
Donotecut proc
        mov al,ChCommandeTick[ebp]
        cmp al,TickCnt
        jne DonoteCutEnd
        mov al,0             ; Set all the volumes to 0
        mov ChVolume[ebp],al 
        call USS_SetVolume
DonotecutEnd:   
        ret
Donotecut Endp

;͸
;o                      Do Note Delay command                             
;                                                                         
;
Donotedelay Proc
        mov al,ChCommandeTick[ebp]
        cmp al,TickCnt             ; Is it time to start the note ?
        jne DoNoteDelayEnd

; Load the previous row data. (Note, Instrument and Volume with no command)
        xor eax,eax
        mov al,ChRNote[ebp]
        mov CNote,ax
        mov al,ChRInstrument[ebp]
        mov CInstr,ax
        mov al,ChRVolume[ebp]
        mov CVolume,ax
        mov CComm,0FFh

; Start the note exactly as it is the tick 0.
        call StartNote

DoNoteDelayEnd:        
        ret
Donotedelay Endp

;͸
;o                    Set volume commands parameter                       
;                                                                         
;
ProcSetVData Proc
        mov ChVolCmdData[ebp],al
        ret
ProcSetVData Endp

;͸
;o                  Process Volume fine down command                      
;                                                                         
;
ProcVfvoldown Proc
        mov bl,al
        mov al,ChVolume[ebp]
        sub al,bl
        jnc ProcVfvoldownEnd
        xor al,al
ProcVfvoldownEnd:
        mov ChVolume[ebp],al
        call USS_SetVolume
        ret
ProcVfvoldown Endp

;͸
;o                   Process Volume fine up command                       
;                                                                         
;
ProcVfvolup Proc
        mov bl,al
        mov al,ChVolume[ebp]
        add al,bl       
        cmp al,40h
        jbe ProcVfvolupEnd
        mov al,40h
ProcVfvolupEnd:
        mov ChVolume[ebp],al
        call USS_SetVolume
        ret
ProcVfvolup Endp

;͸
;o               Process "Volume" Set vibrato speed command               
;                                                                         
;
ProcSetVibSpeed proc
        cmp al,0
        je NoVibSpeed
        mov ChVibSpeed[ebp],al
NovVibSpeed:    
        ret
ProcSetVibSpeed Endp

;͸
;o                Process "Volume" Vibrato command                        
;                                                                         
;
ProcVvibrato proc
        cmp al,0
        je NoVibDepth
        mov ChVibDepth[ebp],al
NovVibDephth:   
        ret
ProcVvibrato Endp

;͸
;o               Process "Volume" Set Panning command                     
;                                                                         
;
ProcVpanning proc
        shl ax,4
        call USS_SetPanning
        ret
ProcVPanning Endp

;͸
;o              Process 'Volume' Porta to note command                    
;                                                                         
;
ProcVportanote proc
        shl al,4
        cmp al,0
        je ProcvPortanoteNext
        mov ChPortaToNoteData[ebp],al
ProcvPortanoteNext:
        cmp CNote,0
        je ProcvPortanoteEnd
        call USS_GetSample
        mov bx,CNote
        call Get_NotePeriod
        mov ChPortaToNotePeriode[2*ebp],ax
ProcvPortanoteEnd:
        ret
ProcVportanote Endp

DoVvolsldown proc
        mov al,ChVolume[ebp]
        mov bl,ChVolCmdData[ebp]
        sub al,bl
        jnc DoVvolSldownEnd
        xor al,al
DoVvolsldownEnd:
        mov ChVolume[ebp],al
        call USS_SetVolume
        ret
DoVvolsldown Endp

DoVvolslup Proc
        mov al,ChVolume[ebp]
        mov bl,ChVolCmdData[ebp]
        add al,bl       
        cmp al,40h
        jbe DoVvolSlupEnd
        mov al,40h
DoVvolslupEnd:
        mov ChVolume[ebp],al
        call USS_SetVolume
        ret
DoVvolslup Endp

Dovpansll Proc
        call USS_GetPanning
        mov bl,ChVolCmdData[ebp]
        sub al,bl
        jnc VPSlEnd
        xor al,al
VPSlEnd:
        call USS_SetPanning
        ret
DovPansll Endp

Dovpanslr Proc
        call USS_GetPanning
        mov bl,ChVolCmdData[ebp]
        add al,bl       
        jnc VPSrEnd
        mov al,0FFh
VPSrEnd:
        call USS_SetPanning
        ret
Dovpanslr Endp

;=============================================================================

Proccmdtable  label dword

;    Jump label         Number Name                    Source format
  dd ProcArpeggio      ;00-0xy Arpeggio                (MOD)
  dd ProcPortup        ;01-1xx Portamento Up           (MOD)
  dd ProcPortdown      ;02-2xx Portamento Down         (MOD)
  dd ProcPortanote     ;03-3xx Portamento to Note      (MOD)
  dd ProcVibrato       ;04-4xy Vibrato                 (MOD)
  dd ProcVolumeSlide   ;05-5xy Portamento+Volume Slide (MOD)
  dd ProcVolumeSlide   ;06-6xy Vibrato+Volume Slide    (MOD)
  dd ProcTremolo       ;07-7xy Tremolo                 (MOD)
  dd ProcSetPanning1   ;08-8xx Set Panning             (MOD/DMP)
  dd ProcSetOffset     ;09-9xx Set Sample Offset       (MOD)
  dd ProcVolumeSlide   ;10-Axy Volume Slide            (MOD)
  dd ProcJump          ;11-Bxx Jump to pattern         (MOD)
  dd ProcSetVolume     ;12-Cxx Set Volume              (MOD)
  dd ProcBreak         ;13-Dxx Pattern Break           (MOD)
  dd ProcNothing       ;14-Exy Extended Effects (24+x) 
  dd ProcSetTempo      ;15-Fxx Set Speed/Set BPM       (MOD)

  dd ProcGVolume       ;16-Gxx Set Global Volume       (S3M/XM)
  dd ProcGVolumeSlide  ;17-Hxx Global Volume Slide     (XM)
  dd ProcNothing       ;18-I
  dd ProcNothing       ;19-J
  dd ProcTick          ;20-Kxx Key Off (after xx tick) (XM)
  dd ProcEnvPos        ;21-Lxx Set Envelope Pos        (XM)  x
  dd ProcNothing       ;22-M
  dd ProcNothing       ;23-N
  dd ProcNothing       ;24-O
  dd ProcPanningSlide  ;25-Pxx Panning Slide           (XM)
  dd ProcNothing       ;26-Q
  dd ProcMRetrig       ;27-Rxy Multi Retrig Note       (S3M)
  dd ProcNothing       ;28-S
  dd ProcTremor        ;29-Txy Tremor                  (STM)
  dd ProcNothing       ;30-U
  dd ProcNothing       ;31-V
  dd ProcNothing       ;32-W
  dd ProcEFPort        ;33-Xxy Extra Fine Portamento   (S3M) 
  dd ProcNothing       ;34-Y
  dd ProcSynchro       ;35-Zxx Synchro function        (USM) 

  dd ProcNothing       ;36-E0x Set Filter              (MOD) x
  dd ProcFPortUp       ;37-E1x Fine Portamento Up      (MOD)
  dd ProcFPortDown     ;38-E2x Fine Portamento Down    (MOD)
  dd Procgliss         ;39-E3x Glissando Control       (MOD) x
  dd Procvibtype       ;40-E4x Set Vibrato Waveform    (MOD)
  dd ProcNothing       ;41-E5x Set Finetune            (MOD) x
  dd Procpatloop       ;42-E6x Pattern Loop            (MOD)
  dd Proctremtype      ;43-E7x Set Tremolo WaveForm    (MOD)
  dd ProcSetpanning2   ;44-E8x Unused/Set Panning      (MOD/S3M)
  dd Proctick          ;45-E9x Retrig Note             (MOD)
  dd ProcfVolumeup     ;46-EAx Fine Volume Slide Up    (MOD)
  dd ProcfVolumedn     ;47-EBx Fine Volume Slide Down  (MOD)
  dd ProcTick          ;48-ECx Cut Note                (MOD)
  dd ProcTick          ;49-EDx Delay Note              (MOD)
  dd ProcPatternDelay  ;50-EEx Pattern Delay           (MOD)
  dd ProcNothing       ;51-EFx Invert Loop             (MOD) x

;(52d au total)

docmdTable label dword
  dd DoArpeggio        ;00-0xy Arpeggio                (MOD)
  dd DoPortamentoUp    ;01-1xx Portamento Up           (MOD)
  dd DoPortamentoDown  ;02-2xx Portamento Down         (MOD)
  dd DoPortanote       ;03-3xx Portamento to Note      (MOD)
  dd Dovibrato         ;04-4xy Vibrato                 (MOD)
  dd Doportvol         ;05-5xy Portamento+Volume Slide (MOD)
  dd Dovibvol          ;06-6xy Vibrato+Volume Slide    (MOD)
  dd Dotremolo         ;07-7xy Tremolo                 (MOD)
  dd ProcNothing       ;08-8xx Set Panning             (MOD/DMP)
  dd ProcNothing       ;09-9xx Set Sample Offset       (MOD)
  dd Dovolumeslide     ;10-Axy Volume Slide            (MOD)
  dd ProcNothing       ;11-Bxx Jump to pattern         (MOD)
  dd ProcNothing       ;12-Cxx Set Volume              (MOD)
  dd ProcNothing       ;13-Dxx Pattern Break           (MOD)
  dd ProcNothing       ;14-Exy Extended Effects (24+x)
  dd ProcNothing       ;15-Fxx Set Speed/Set BPM       (MOD)

  dd ProcNothing       ;16-Gxx Set Global Volume       (S3M/XM)
  dd DoGvolumeslide    ;17-Hxx Global Volume Slide     (XM)
  dd ProcNothing       ;18-I
  dd ProcNothing       ;19-J
  dd Dokeyoff          ;20-Kxx Key Off (after xx tick) (XM)
  dd ProcNothing       ;21-Lxx Set Envelope Pos        (XM)
  dd ProcNothing       ;22-M
  dd ProcNothing       ;23-N
  dd ProcNothing       ;24-O
  dd DoPanningSlide    ;25-Pxx Panning Slide           (XM)
  dd ProcNothing       ;26-Q
  dd Domretrig         ;27-Rxy Multi Retrig Note       (S3M)
  dd ProcNothing       ;28-S
  dd Dotremor          ;29-Txy Tremor                  (STM)
  dd ProcNothing       ;30-U
  dd ProcNothing       ;31-V
  dd ProcNothing       ;32-W
  dd ProcNothing       ;33-Xxy Extra Fine Portamento   (S3M)
  dd ProcNothing       ;34-Y
  dd ProcNothing       ;35-Zxx Synchro function        (USM) 

  dd ProcNothing       ;36-E0x 
  dd ProcNothing       ;37-E1x Fine Portamento Up      (MOD)
  dd ProcNothing       ;38-E2x Fine Portamento Down    (MOD)
  dd ProcNothing       ;39-E3x Glissando Control       (MOD)
  dd ProcNothing       ;40-E4x Set Vibrato Waveform    (MOD)
  dd ProcNothing       ;41-E5x Set Finetune            (MOD)
  dd ProcNothing       ;42-E6x Pattern Loop            (MOD)
  dd ProcNothing       ;43-E7x Set Tremolo WaveForm    (MOD)
  dd ProcNothing       ;44-E8x Unused/Set Panning      (MOD/S3M)
  dd Doretrig          ;45-E9x Retrig Note             (MOD)
  dd ProcNothing       ;46-EAx Fine Volume Slide Up    (MOD)
  dd ProcNothing       ;47-EBx Fine Volume Slide Down  (MOD)
  dd Donotecut         ;48-ECx Cut Note                (MOD)
  dd Donotedelay       ;49-EDx Delay Note              (MOD)
  dd ProcNothing       ;50-EEx Pattern Delay           (MOD)
  dd ProcNothing

ProcVolTable label dword
  dd ProcSetVData
  dd ProcSetVData
  dd ProcVfvoldown
  dd ProcVfvolup
  dd ProcSetVibSpeed
  dd ProcVvibrato
  dd ProcVpanning
  dd ProcSetVData
  dd ProcSetVData
  dd ProcVportanote

DoVolTable label dword
  dd DoVvolsldown
  dd DoVvolslup
  dd ProcNothing
  dd ProcNothing
  dd ProcNothing
  dd Dovibrato
  dd ProcNothing
  dd Dovpansll
  dd Dovpanslr
  dd Doportanote

CODE32 ENDS
end